##############################################################################
#
# Copyright (c) 2003-2004 Hajime Nakagami<nakagami@da2.so-net.ne.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products 
#    derived from this software without specific prior written permission. 
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
##############################################################################
import char_map

def splitJapanese(utext, glob):
    char_state = char_map.DELM
    word = u''
    result = []
    for ch in utext:
        ch = char_map.convert_char(ch)
        if glob and char_state != char_map.DELM \
                                        and (ch == u'*' or ch == u'?'):
            word += ch
            continue
        new_state = char_map.guess_charclass(ch)
        if new_state == char_map.ZEN_DEPEND:
            if char_state == char_map.ZEN_KANA \
                                or char_state == char_map.ZEN_HIRA:
                new_state = char_state
            else:
                new_state = char_map.DELM
        if new_state == char_map.DELM:
            if char_state != char_map.DELM:
                result.append(word)
                word = u''
                char_state = char_map.DELM
        elif new_state != char_state:
            if char_state != char_map.DELM:
                result.append(word)
                word = u''
            word += ch
            char_state = new_state
        else:
            word += ch

    if char_state != char_map.DELM:
            result.append(word)

    return result
